
Ruby - Bug #14926

Different results between Enumerable#sum and #reduce when Float::INFINITY present

07/20/2018 04:25 PM - swistak35 (Rafał Łasocha)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.5.1p57 (2018-03-29 revision

63029) [x86_64-linux]

Backport: 2.3: DONTNEED, 2.4: DONE, 2.5:

DONE

Description

When Float::INFINITY is present in array, Enumerable#sum and Enumerable#reduce(0, &:+) are giving different results.

puts [Float::INFINITY].sum

puts [Float::INFINITY].reduce(0, &:+)

 results in

NaN

Infinity

 And I would expect both of them to be Infinity (meaning: #sum is working incorrectly).

Checked on ruby 2.5.1p57 and ruby 2.4.3p205, both have the same bug.

Associated revisions

Revision 67cacdb83610889d1153409362cc38448affb4e8 - 07/22/2018 10:47 AM - nobu (Nobuyoshi Nakada)

fix sum on infinity

array.c (rb_ary_sum): consider non-finite floats.

[ruby-core:88024] [Bug #14926]

enum.c (sum_iter): ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@64014 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 67cacdb83610889d1153409362cc38448affb4e8 - 07/22/2018 10:47 AM - nobu (Nobuyoshi Nakada)

fix sum on infinity

array.c (rb_ary_sum): consider non-finite floats.

[ruby-core:88024] [Bug #14926]

enum.c (sum_iter): ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@64014 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 67cacdb8 - 07/22/2018 10:47 AM - nobu (Nobuyoshi Nakada)

fix sum on infinity

array.c (rb_ary_sum): consider non-finite floats.

[ruby-core:88024] [Bug #14926]

enum.c (sum_iter): ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@64014 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ba757763464cb3cd344454bb8d8e062ca92d2a3d - 08/27/2018 02:11 PM - U.Nakamura 

merge revision(s) 64014: [Backport #14926]
    fix sum on infinity

    * array.c (rb_ary_sum): consider non-finite floats.

      [ruby-core:88024] [Bug #14926]

    * enum.c (sum_iter): ditto.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@64562 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ba757763464cb3cd344454bb8d8e062ca92d2a3d - 08/27/2018 02:11 PM - U.Nakamura 

merge revision(s) 64014: [Backport #14926]

    fix sum on infinity

    * array.c (rb_ary_sum): consider non-finite floats.

      [ruby-core:88024] [Bug #14926]

    * enum.c (sum_iter): ditto.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@64562 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ba757763 - 08/27/2018 02:11 PM - U.Nakamura 

merge revision(s) 64014: [Backport #14926]

    fix sum on infinity

    * array.c (rb_ary_sum): consider non-finite floats.

      [ruby-core:88024] [Bug #14926]

    * enum.c (sum_iter): ditto.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@64562 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 2c26edc15c4d30494601d5df11daea4a26a38465 - 09/01/2018 02:31 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 64014: [Backport #14926]

    fix sum on infinity

    * array.c (rb_ary_sum): consider non-finite floats.

      [ruby-core:88024] [Bug #14926]

    * enum.c (sum_iter): ditto.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@64603 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 2c26edc15c4d30494601d5df11daea4a26a38465 - 09/01/2018 02:31 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 64014: [Backport #14926]

    fix sum on infinity

    * array.c (rb_ary_sum): consider non-finite floats.

      [ruby-core:88024] [Bug #14926]

    * enum.c (sum_iter): ditto.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@64603 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 2c26edc1 - 09/01/2018 02:31 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 64014: [Backport #14926]

    fix sum on infinity

    * array.c (rb_ary_sum): consider non-finite floats.

      [ruby-core:88024] [Bug #14926]

    * enum.c (sum_iter): ditto.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@64603 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History
#1 - 07/20/2018 07:26 PM - shevegen (Robert A. Heiler)

I sort of agree; I would have expected the same result.

Other arrays with numbers output the same result:

[1, 2, 3, 4, 5, 6, 7, 8, 9, 10].reduce(0, &:+) # => 55

[1, 2, 3, 4, 5, 6, 7, 8, 9, 10].sum            # => 55

 So the result of .sum on infinity seems awkward if .reduce(0, &:+) leads

to Infinity.

I am a bit surprised about infinity though:

a = [Float::INFINITY].reduce(0, &:+)

b = [Float::INFINITY]

puts a

puts b

puts (a == b) # => false

 I also would have expected the latter to be true. Infinity confuses

me a lot so I will leave others to this issue. :)

#2 - 07/21/2018 10:37 PM - marcandre (Marc-Andre Lafortune)

Yes, definitely a bug in the algorithm trying to minimize floating errors. Result must be Float::INFINITY.

shevegen (Robert A. Heiler) wrote:

I am a bit surprised about infinity though:

a = [Float::INFINITY].reduce(0, &:+)

b = [Float::INFINITY]

puts (a == b) # => false

 

Using p instead of puts will show you you are comparing an array with float...

p a  # => Infinity

p b  # => [Infinity]

 

#3 - 07/22/2018 10:39 AM - nobu (Nobuyoshi Nakada)

- Backport changed from 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5: UNKNOWN to 2.3: DONTNEED, 2.4: REQUIRED, 2.5: REQUIRED

#4 - 07/22/2018 10:47 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset trunk|r64014.

fix sum on infinity

array.c (rb_ary_sum): consider non-finite floats.

[ruby-core:88024] [Bug #14926]

enum.c (sum_iter): ditto.

#5 - 08/27/2018 02:11 PM - usa (Usaku NAKAMURA)

- Backport changed from 2.3: DONTNEED, 2.4: REQUIRED, 2.5: REQUIRED to 2.3: DONTNEED, 2.4: DONE, 2.5: REQUIRED

ruby_2_4 r64562 merged revision(s) 64014.

#6 - 09/01/2018 02:31 AM - nagachika (Tomoyuki Chikanaga)
bugs.ruby-lang.org/issues/14926
https://redmine.ruby-lang.org/issues/14926


- Backport changed from 2.3: DONTNEED, 2.4: DONE, 2.5: REQUIRED to 2.3: DONTNEED, 2.4: DONE, 2.5: DONE

ruby_2_5 r64603 merged revision(s) 64014.
